/**
 * 
 */
package it.unicam.cs.asdl1617.sorting;

import java.util.ArrayList;
import java.util.List;

/**
 * Implementazione dell'algoritmo di Merge Sort integrata nel framework di
 * valutazione numerica.
 * 
 * @author luca
 *
 */
public class MergeSort<E extends Comparable<E>> implements SortingAlgorithm<E> {

    @Override
    public SortingAlgorithmResult<E> sort(List<E> l) {
        // TOFIX Eliminare il caso della lista vuota
        // Chiamo la procedura effettiva ricorsiva
        return recSort(l, 0, l.size() - 1);
    }

    /*
     * Reale procedura ricorsiva del Merge Sort
     */
    private SortingAlgorithmResult<E> recSort(List<E> l, int start, int stop) {
        if (start == stop) {
            // C'è solo un elemento
            return new SortingAlgorithmResult<E>(l, 0);
        }
        int countCompare = 0;
        int nElements = stop - start + 1;
        int middle = start + (nElements / 2) - 1;
        // L'elemento middle, nel caso in cui il numero degli
        // elementi è dispari, è scelto in modo che l'elemento
        // in più vada nella parte destra
        SortingAlgorithmResult<E> left = this.recSort(l, start, middle);
        SortingAlgorithmResult<E> right = this.recSort(l, middle + 1, stop);
        return this.merge(l, start, middle, stop);

    }

    /*
     * Procedura che fa il merge delle sottoliste ordinate che vanno da start a
     * middle e da middle + 1 a stop.
     * 
     * Crea delle copie delle sottoliste e scrive nella lista originale l
     */
    private SortingAlgorithmResult<E> merge(List<E> l, int start, int middle,
            int stop) {
        int countCompare = 0;
        // Creo due liste accessorie per salvare gli elementi
        // dei due sottoarray ordinati di cui fare il merge
        // Sono costretto a farlo perché il risultato lo scrivo
        // su l, quindi mi scriverei sopra
        List<E> leftCopy = new ArrayList<E>();
        for (int i = start; i <= middle; i++)
            leftCopy.add(l.get(i));
        List<E> rightCopy = new ArrayList<E>();
        for (int i = middle + 1; i <= stop; i++)
            rightCopy.add(l.get(i));
        // TOFINISH
        // Incrementa countCompare
        // return null;
    }

    @Override
    public String getName() {
        return "MergeSort";
    }
}
